#!/usr/local/bin/perl

#=============================================================================#
# c[ : Tree (tree.pl)                                                     #
#                                                                             #
# Windows NT/2000  tree R}h Perl                                   #
#                                                                             #
# Edited by tazawa                                                            #
#                                                                             #
# 2000.11.14 - Ver 0.5   : c[rŏo͂悤ɏo                   #
# 2000.11.15 - Ver 0.5.1 : Jg pwd  Cwd Ŏ擾悤ɏC       #
# 2002.10.26 - Ver 0.6   : -nA-d IvV̒ǉAt@Co͂Wo͂  #
# 2006.12.19 - Ver 0.7   : -m IvV MD5 nbV̏o͂ǉ           #
#=============================================================================#

#-----------------------------------------------------------------------------#
# O[o錾                                                              #
#-----------------------------------------------------------------------------#
# W[
#use strict;
use Cwd;     # JgfBNg擾
use MD5;  # MD5

#-----------------------------------------------------------------------------#
# ݒ荀                                                                    #
#-----------------------------------------------------------------------------#
my $max_depth = 64;     # fBNg̍ő̐[
my $dir_only  = 'OFF';  # fBNĝݎ擾tO
my $md5_flg   = 'OFF';  # MD5 nbV擾tO

#-----------------------------------------------------------------------------#
# C                                                                  #
#-----------------------------------------------------------------------------#
# 
for(my $i = 0; $i < (@ARGV); $i++)
{
	next if($ARGV[$i] !~ /^\-/);

	if($ARGV[$i] eq '-n')
	{
		my $num = $1 if($ARGV[$i + 1] =~ /(\d+)/);
		$max_depth = $num if($num > 0 and $num <= 64);
	}

	$dir_only = 'ON' if($ARGV[$i] eq '-d');
	$md5_flg  = 'ON' if($ARGV[$i] eq '-m');
}

$depth = 1;  # Jgȉ\̂ŏl 1
%last = ();

$dir = cwd();  # JgfBNg
print "$dir\n";

&dirprint($depth);

#-----------------------------------------------------------------------------#
# ċAWbN                                                                #
#-----------------------------------------------------------------------------#
sub dirprint
{
	my($depth) = @_[0];
	my(@files, $file, $flag, $i);
	@tmp = sort(glob("*"));  # St@C/fBNgz

	# t@CɎĂ
	foreach $file (@tmp)
	{
		if(-f $file and $dir_only ne 'ON')
		{
			push(@files, $file);
		}
	}

	foreach $file (@tmp)
	{
		if(-d $file)
		{
			push(@files, $file);
		}
	}

	foreach $file (@files)
	{
		for($i = 1; $i < $depth; $i++)  # [ | o
		{
			if($last{$i} eq "on")
			{
				print "   ";
			}
			else
			{
				print "b ";
			}
		}

		if($file eq $files[$#files])  # Ō̓Y
		{
			print " ";
			$last{$depth} = "on";
		}
		else
		{
			print " ";
			$last{$depth} = "off";
		}

		print "$file";  # Oo

		if($md5_flg eq 'ON' and -f $file)
		{
			open(SRC, cwd() . "/" . $file) or die;
			my $context = new MD5;
			$context->addfile(SRC);
			my $digest = $context->hexdigest();
			close(SRC);

			print " [$digest]";
		}

		print "\n";

		if(-d $file)  # fBNgȂ
		{
			$depth++;  # [CNg
			if($depth <= $max_depth)
			{
				chdir("$file");
				&dirprint($depth);  # ċAĂяo
				chdir("..");
			}
			$depth--;  # [fNg
		}
	}
}

